#// posted.awk
#// Display one entry in the post list
#// 25.04.2015
#// 
#// Copyright (C) 2015  Balthasar Szczepański
#// 
#// This program is free software: you can redistribute it and/or modify
#// it under the terms of the GNU Affero General Public License as
#// published by the Free Software Foundation, either version 3 of the
#// License, or (at your option) any later version.
#// 
#// This program is distributed in the hope that it will be useful,
#// but WITHOUT ANY WARRANTY; without even the implied warranty of
#// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#// GNU Affero General Public License for more details.
#// 
#// You should have received a copy of the GNU Affero General Public License
#// along with this program.  If not, see <http://www.gnu.org/licenses/>.


BEGIN{
	FS="="
	for(i=0;i<256;++i)
	{
		ch=sprintf("%c",i)
		hex=sprintf("%02X",i);
		ch2hex[ch]=hex
	}
};
{
	gsub(/[\r\n]/,"",$0)
	eq=index($0,"=")
	argtab[substr($0,1,eq-1)]=substr($0,eq+1)
};
END{
	if(((pass,!=urldecode(argtab["password"]))||(name!=urldecode(argtab["username"])))&&cat!="st")
		exit 1;
	if (r2==0)
		class="plw"
	else
		class="plv"
	print "<tr class=\""class"\"><td class=\"plk\">"argtab["y"]"-"argtab["m"]"-"argtab["d"]" "argtab["h"]":00</td><td class=\"plk\">"argtab["username_h"]"</td><td class=\"plk\">"argtab["subject_h"]"</td><td class=\"plk\"><a href=\"/silentbot/view?v="cat argtab["timenumber"](cat=="wt"?"&amp;key="argtab["key"]:"")"\">view</a> <a href=\"/silentbot/post?q="cat argtab["timenumber"](cat=="wt"?"&amp;key="argtab["key"]:"")"\">quote</a> "(cat=="wt"?"<a href=\"/silentbot/post?e="cat argtab["timenumber"]"&amp;key="argtab["key"]"\">edit</a> ":"")"<a href=\"/silentbot/remove?r="cat argtab["timenumber"](cat=="wt"?"&amp;key="argtab["key"]:"")"\">remove</a>"(argtab["ID"]!=""?" <a href=\"http://forums.xkcd.com/viewtopic.php?p="argtab["ID"]"#p"argtab["ID"]"\">OTT</a>":"")"</td></tr>"
}
# function urlencode(name,all,   len,iii,escaped,ch)
# {
	# len=length(name)
	# escaped=""
	# for(iii=1;iii<=len;++iii)
	# {
		# ch=substr(name,iii,1);
		# if ((ch ~ /[a-zA-Z0-9\.\-_~]/)&&(all==""))
			# escaped = escaped ch
		# else
			# escaped = escaped "%" ch2hex[ch]
	# }
	# return escaped
# }
function urldecode(ht   ,i,j,un,num)
{
	while ((i=match(ht, /%[0-9a-fA-F][0-9a-fA-F]/))!=0)#
	{
		un=un substr(ht, 1, i-1)
		ht=substr(ht, i)
		num=toupper(substr(ht, 2, 2))
		un=un hex2ch[num]
		ht=substr(ht, 4)
	}
	un=un ht
	return un
}