#// mview.awk
#// Display one post
#// 25.04.2015
#// 
#// Copyright (C) 2015  Balthasar Szczepański
#// 
#// This program is free software: you can redistribute it and/or modify
#// it under the terms of the GNU Affero General Public License as
#// published by the Free Software Foundation, either version 3 of the
#// License, or (at your option) any later version.
#// 
#// This program is distributed in the hope that it will be useful,
#// but WITHOUT ANY WARRANTY; without even the implied warranty of
#// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#// GNU Affero General Public License for more details.
#// 
#// You should have received a copy of the GNU Affero General Public License
#// along with this program.  If not, see <http://www.gnu.org/licenses/>.

BEGIN{
	FS="="
};
{
	eq=index($0,"=")
	argtab[substr($0,1,eq-1)]=substr($0,eq+1)
};
END{
	if(key!=argtab["key"]&&cat=="wt"&&argtab["key"]!="")
	{
		print"<b class=\"br\">Invalid key.</b><br><br>"
		exit
	}
	print "<div id=\""cat argtab["timenumber"]"\" class=\"pl\">"
	print "<div class=\"pls\">"argtab["subject_h"]"</div>"
	print "<div class=\"plt\">"argtab["username_h"]" &bull; "argtab["y"]"-"argtab["m"]"-"argtab["d"]" "argtab["h"]":00 <div class=\"pr\"><a class=\"bi\" href=\"/silentbot/post?q="cat argtab["timenumber"](cat=="wt"?"&amp;key="argtab["key"]:"")"\">quote</a> "((cat=="wt")?("<a class=\"bi\" href=\"/silentbot/post?e="cat argtab["timenumber"]"&amp;key="argtab["key"]"\">edit</a> "):"")"<a class=\"bi\" href=\"/silentbot/remove?r="cat argtab["timenumber"](cat=="wt"?"&amp;key="argtab["key"]:"")"\">remove</a> "(argtab["ID"]!=""?" <a class=\"bi\" href=\"http://forums.xkcd.com/viewtopic.php?p="argtab["ID"]"#p"argtab["ID"]"\">OTT</a>":"")"</div></div>"
	print "<div class=\"plw\">"((argtab["HTML"]!="")?argtab["HTML"]:argtab["BBHTML"])"</div>"
	print "</div>"
}
